grammar Arith;

NUMBER : [1-9][0-9]*;
NEWLINE: '\n';
WS     : [ \t\r]+ -> skip;
CELLID : [A-Z_]+[1-9][0-9]*;

PLUS  : '+';
MINUS : '-';
MULT  : '*';
DIV   : '/';
LPAR  : '(';
RPAR  : ')';

input
    : plusOrMinus NEWLINE? EOF # All
    ;

plusOrMinus 
    : plusOrMinus PLUS multOrDiv  # Plus
    | plusOrMinus MINUS multOrDiv # Minus
    | multOrDiv                   # ToMultOrDiv
    ;

multOrDiv
    : multOrDiv MULT ident   # Multiply
    | multOrDiv DIV  ident   # Divide
    | ident                  # ToIdent
    ;

ident
    : NUMBER                # Number
    | LPAR plusOrMinus RPAR # Parens
    ;
