/* arithparse.mly: ocaml yacc sourc file defining a parser. Note the
   C-style comments rather than OCaml style */

/* first section defines token types used by parser using % directives */
%token <int> INT
%token PLUS MINUS TIMES SLASH
%token OPAREN CPAREN EOL
%type <int> main                             /* indicates the type returned by production main */
%start main                                  /* entry production for parser */
/* end first section */
%%
/* second section which shows expressions */
main:                                        /* initial production */
  | plusminus EOL           { $1 }           /* $1 refers to value of first production */
;
plusminus:                                   /* addition and subtraction */
  | muldiv                  { $1 }           /* could be just mul/div */
  | plusminus PLUS  muldiv  { $1 + $3 }      /* or an addition */
  | plusminus MINUS muldiv  { $1 - $3 }      /* or a subtraction */
;
muldiv:                                      /* multiplication and division */
  | ident                    { $1 }          /* could be just and identifier */
  | muldiv TIMES ident       { $1 * $3 }     /* or a multiplication */
  | muldiv SLASH ident       { $1 / $3 }     /* or a division */
;
ident:                                       /* identifier */
  | INT                     { $1 }           /* integer constant */
  | OPAREN plusminus CPAREN { $2 }           /* opening parenthesis */
;
